Package org.apache.solr.client.solrj.impl

## Class LBSolrClient

- java.lang.Object
- - org.apache.solr.client.solrj.SolrClient
  - - org.apache.solr.client.solrj.impl.LBSolrClient

All Implemented Interfaces:
  `Closeable`, `Serializable`, `AutoCloseable`

Direct Known Subclasses:
  `LBHttp2SolrClient`, `LBHttpSolrClient`

    public abstract class LBSolrClient
    extends SolrClient

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `LBSolrClient.Req`
`static class` `LBSolrClient.Rsp`
`protected static class` `LBSolrClient.ServerIterator`
`protected static class` `LBSolrClient.ServerWrapper`

### Field Summary

Fields
`protected ResponseParser` `parser`
`protected Set<String>` `queryParams`
`protected RequestWriter` `requestWriter`
`protected static Set<Integer>` `RETRY_CODES`
`protected Map<String,​LBSolrClient.ServerWrapper>` `zombieServers`

### Constructor Summary

Constructors
`LBSolrClient​(List<String> baseSolrUrls)`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`void` `addQueryParams​(String queryOnlyParam)`
`void` `addSolrServer​(String server)`
`protected Exception` `addZombie​(String serverStr, Exception e)`
`void` `close()`
`protected LBSolrClient.ServerWrapper` `createServerWrapper​(String baseUrl)`
`protected Exception` `doRequest​(String baseUrl, LBSolrClient.Req req, LBSolrClient.Rsp rsp, boolean isNonRetryable, boolean isZombie)`
`protected abstract SolrClient` `getClient​(String baseUrl)`
`ResponseParser` `getParser()`
`Set<String>` `getQueryParams()`
`RequestWriter` `getRequestWriter()`
`static String` `normalize​(String server)`
`protected LBSolrClient.ServerWrapper` `pickServer​(LBSolrClient.ServerWrapper[] aliveServerList, SolrRequest<?> request)` Pick a server from list to execute request.
`String` `removeSolrServer​(String server)`
`LBSolrClient.Rsp` `request​(LBSolrClient.Req req)` Tries to query a live server from the list provided in Req.
`NamedList<Object>` `request​(SolrRequest<?> request, String collection)` Tries to query a live server.
`NamedList<Object>` `request​(SolrRequest<?> request, String collection, Integer numServersToTry)`
`void` `setAliveCheckInterval​(int interval)` LBHttpSolrServer keeps pinging the dead servers at fixed interval to find if it is alive.
`void` `setParser​(ResponseParser parser)` Changes the `ResponseParser` that will be used for the internal SolrServer objects.
`void` `setQueryParams​(Set<String> queryParams)` Expert Method.
`void` `setRequestWriter​(RequestWriter requestWriter)` Changes the `RequestWriter` that will be used for the internal SolrServer objects.
`protected void` `updateAliveList()`

### Methods inherited from class org.apache.solr.client.solrj.SolrClient

`add, add, add, add, add, add, add, add, add, add, addBean, addBean, addBean, addBean, addBeans, addBeans, addBeans, addBeans, addBeans, addBeans, commit, commit, commit, commit, commit, commit, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteByQuery, deleteByQuery, deleteByQuery, deleteByQuery, getBinder, getById, getById, getById, getById, getById, getById, getById, getById, getContext, optimize, optimize, optimize, optimize, optimize, optimize, ping, ping, query, query, query, query, queryAndStreamResponse, queryAndStreamResponse, queryAndStreamResponse, request, rollback, rollback`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### RETRY_CODES

    protected static final Set<Integer> RETRY_CODES

#### zombieServers

    protected final Map<String,​LBSolrClient.ServerWrapper> zombieServers

#### parser

    protected volatile ResponseParser parser

#### requestWriter

    protected volatile RequestWriter requestWriter

#### queryParams

    protected Set<String> queryParams

### Constructor Detail

#### LBSolrClient

    public LBSolrClient​(List<String> baseSolrUrls)

### Method Detail

#### updateAliveList

    protected void updateAliveList()

#### createServerWrapper

    protected LBSolrClient.ServerWrapper createServerWrapper​(String baseUrl)

#### getQueryParams

    public Set<String> getQueryParams()

#### setQueryParams

    public void setQueryParams​(Set<String> queryParams)

Expert Method.

Parameters:
  `queryParams` - set of param keys to only send via the query string

#### addQueryParams

    public void addQueryParams​(String queryOnlyParam)

#### normalize

    public static String normalize​(String server)

#### request

    public LBSolrClient.Rsp request​(LBSolrClient.Req req)
                             throws SolrServerException,
                                    IOException

Tries to query a live server from the list provided in Req. Servers in the dead pool are skipped. If a request fails due to an IOException, the server is moved to the dead pool for a certain period of time, or until a test request on that server succeeds.

Servers are queried in the exact order given (except servers currently in the dead pool are skipped). If no live servers from the provided list remain to be tried, a number of previously skipped dead servers will be tried. Req.getNumDeadServersToTry() controls how many dead servers will be tried.

If no live servers are found a SolrServerException is thrown.

Parameters:
  `req` - contains both the request as well as the list of servers to query
Returns:
  the result of the request
Throws:
  `IOException` - If there is a low-level I/O error.
  `SolrServerException`

#### doRequest

    protected Exception doRequest​(String baseUrl,
                                  LBSolrClient.Req req,
                                  LBSolrClient.Rsp rsp,
                                  boolean isNonRetryable,
                                  boolean isZombie)
                           throws SolrServerException,
                                  IOException

Throws:
  `SolrServerException`
  `IOException`

#### getClient

    protected abstract SolrClient getClient​(String baseUrl)

#### addZombie

    protected Exception addZombie​(String serverStr,
                                  Exception e)

#### setAliveCheckInterval

    public void setAliveCheckInterval​(int interval)

LBHttpSolrServer keeps pinging the dead servers at fixed interval to find if it is alive. Use this to set that interval

Parameters:
  `interval` - time in milliseconds

#### getParser

    public ResponseParser getParser()

#### setParser

    public void setParser​(ResponseParser parser)

Changes the `ResponseParser` that will be used for the internal SolrServer objects.

Parameters:
  `parser` - Default Response Parser chosen to parse the response if the parser were not specified as part of the request.
See Also:
  `SolrRequest.getResponseParser()`

#### setRequestWriter

    public void setRequestWriter​(RequestWriter requestWriter)

Changes the `RequestWriter` that will be used for the internal SolrServer objects.

Parameters:
  `requestWriter` - Default RequestWriter, used to encode requests sent to the server.

#### getRequestWriter

    public RequestWriter getRequestWriter()

#### addSolrServer

    public void addSolrServer​(String server)
                       throws MalformedURLException

Throws:
  `MalformedURLException`

#### removeSolrServer

    public String removeSolrServer​(String server)

#### request

    public NamedList<Object> request​(SolrRequest<?> request,
                                     String collection)
                              throws SolrServerException,
                                     IOException

Tries to query a live server. A SolrServerException is thrown if all servers are dead. If the request failed due to IOException then the live server is moved to dead pool and the request is retried on another live server. After live servers are exhausted, any servers previously marked as dead will be tried before failing the request.

Specified by:
  `request` in class `SolrClient`
Parameters:
  `request` - the SolrRequest.
  `collection` - the collection to execute the request against
Returns:
  response
Throws:
  `IOException` - If there is a low-level I/O error.
  `SolrServerException` - if there is an error on the server

#### request

    public NamedList<Object> request​(SolrRequest<?> request,
                                     String collection,
                                     Integer numServersToTry)
                              throws SolrServerException,
                                     IOException

Throws:
  `SolrServerException`
  `IOException`

#### pickServer

    protected LBSolrClient.ServerWrapper pickServer​(LBSolrClient.ServerWrapper[] aliveServerList,
                                                    SolrRequest<?> request)

Pick a server from list to execute request. By default servers are picked in round-robin manner, custom classes can override this method for more advance logic

Parameters:
  `aliveServerList` - list of currently alive servers
  `request` - the request will be sent to the picked server
Returns:
  the picked server

#### close

    public void close()